{

Fast Memory Manager: Messages

Portuguese (Brazil) translation by Johni Jeferson Capeletto (capeletto@gmail.com) - Love you Julia.

}

unit FastMM4Messages;

interface

{$Include FastMM4Options.inc}

const
  {The name of the debug info support DLL}
  FullDebugModeLibraryName = 'FastMM_FullDebugMode.dll';
  {Event log strings}
  LogFileExtension = '_MemoryManager_EventosLog.txt'#0;
  CRLF = #13#10;
  EventSeparator = '--------------------------------';
  {Class name messages}
  UnknownClassNameMsg = 'Desconhecida';
  {Memory dump message}
  MemoryDumpMsg = #13#10#13#10'Dump de memria atual de 256 bytes iniciando no endereo ';
  {Block Error Messages}
  BlockScanLogHeader = 'Bloco alocado logado por LogAllocatedBlocksToFile. O tamanho : ';
  ErrorMsgHeader = 'FastMM detectou um erro durante ';
  GetMemMsg = 'GetMem';
  FreeMemMsg = 'FreeMem';
  ReallocMemMsg = 'ReallocMem';
  BlockCheckMsg = 'busca de bloco livre';
  OperationMsg = ' operao. ';
  BlockHeaderCorruptedMsg = 'O cabealho do bloco foi corrompido. ';
  BlockFooterCorruptedMsg = 'O rodap do bloco foi corrompido. ';
  FreeModifiedErrorMsg = 'FastMM detectou que um bloco foi modificado aps ter sido liberado. ';
  FreeModifiedDetailMsg = #13#10#13#10'Modified byte offsets (and lengths): ';
  DoubleFreeErrorMsg = 'Uma tentativa foi feita para liberar/realocar um bloco no alocado.';
  WrongMMFreeErrorMsg = 'An attempt has been made to free/reallocate a block that was allocated through a different FastMM instance. Check your memory manager sharing settings.';
  PreviousBlockSizeMsg = #13#10#13#10'O tamanho anterior do bloco era: ';
  CurrentBlockSizeMsg = #13#10#13#10'O tamanho do bloco : ';
  PreviousObjectClassMsg = #13#10#13#10'O bloco foi usado anteriormente por um objeto da classe: ';
  CurrentObjectClassMsg = #13#10#13#10'O bloco est sendo usado por um objeto da classe: ';
  PreviousAllocationGroupMsg = #13#10#13#10'O grupo de alocao era: ';
  PreviousAllocationNumberMsg = #13#10#13#10'O nmero da alocao era: ';
  CurrentAllocationGroupMsg = #13#10#13#10'O grupo de alocao : ';
  CurrentAllocationNumberMsg = #13#10#13#10'O nmero da alocao : ';
  BlockErrorMsgTitle = 'Erro de memria detectado';
  VirtualMethodErrorHeader = 'FastMM detectou uma tentativa de chamada a um mtodo virtual de um objeto liberado. Uma violao de acesso ser disparada para abortar a operao corrente.';
  InterfaceErrorHeader = 'FastMM detectou uma tentativa de uso de uma interface de um objeto liberado. Uma violao de acesso ser disparada para abortar a operao corrente.';
  BlockHeaderCorruptedNoHistoryMsg = ' Infelizmente o cabealho do bloco foi corrompido e a histria no est disponvel.';
  FreedObjectClassMsg = #13#10#13#10'Classe do objeto liberado: ';
  VirtualMethodName = #13#10#13#10'Mtodo virtual: ';
  VirtualMethodOffset = 'Offset +';
  VirtualMethodAddress = #13#10#13#10'Endereo do mtodo virtual: ';
  {Stack trace messages}
  CurrentThreadIDMsg = #13#10#13#10'O ID da thread atual  0x';
  CurrentStackTraceMsg = ', e a anlise da pilha interna (endereos de retorno) que levaram a este erro :';
  ThreadIDPrevAllocMsg = #13#10#13#10'Este bloco foi criado anteriormente pela thread 0x';
  ThreadIDAtAllocMsg = #13#10#13#10'Este bloco foi alocado pela thread 0x';
  ThreadIDAtFreeMsg = #13#10#13#10'Este bloco foi liberado anteriormente pela thread 0x';
  ThreadIDAtObjectAllocMsg = #13#10#13#10'O objeto foi alocado pela thread 0x';
  ThreadIDAtObjectFreeMsg = #13#10#13#10'O objeto foi liberado posteriormente pela thread 0x';
  StackTraceMsg = ', e a anlise da pilha interna (endereos de retorno) no momento era:';
  {Installation Messages}
  AlreadyInstalledMsg = 'FastMM4 j foi instalado.';
  AlreadyInstalledTitle = 'J foi instalado.';
  OtherMMInstalledMsg = 'FastMM4 no pode ser instalado j que outro gerenciador externo '
    + 'de memria j foi instalado.'#13#10'Se voc quer usar o FastMM4, '
    + 'tenha certeza que a unit FastMM4.pas seja a primeira na seo "uses"'
    + #13#10'do arquivo .dpr do seu projeto.';
  OtherMMInstalledTitle = 'Impossvel instalar FastMM4 - Outro gerenciador de memria j est instalado';
  MemoryAllocatedMsg = 'O FastMM4 no pode ser instalado j que a memria j foi '
    + 'alocada atravs do gerenciador de memria padro.'#13#10'FastMM4.pas DEVE '
    + 'ser a primeira unit no arquivo .dpr do seu projeto, caso contrrio a memria pode '
    + 'ser alocada'#13#10'atravs do gerenciador de memria padro antes que o FastMM '
    + 'ganhe o controle. '#13#10#13#10'Se voc estiver usando um interceptador de excees '
    + 'como MadExcept (ou qualquer outra ferramenta que modifica a ordem de inicializao da '
    + 'unit),'#13#10'v para sua pgina de configurao e tenha certeza que a unit '
    + 'FastMM4.pas seja inicializada antes de qualquer outra unit.';
  MemoryAllocatedTitle = 'Impossvel instalar FastMM4 - A memria j foi alocada';
  {Leak checking messages}
  LeakLogHeader = 'Um bloco de memria vazou. O tamanho : ';
  LeakMessageHeader = 'Essa aplicao teve vazamentos de memria. ';
  SmallLeakDetail = 'Os vazamentos dos blocos pequenos so'
{$ifdef HideExpectedLeaksRegisteredByPointer}
    + ' (excluindo os vazamentos esperados registrados por ponteiro)'
{$endif}
    + ':'#13#10;
  LargeLeakDetail = 'O tamanho dos vazamentos dos blocos mdios e grandes so'
{$ifdef HideExpectedLeaksRegisteredByPointer}
    + ' (excluindo os vazamentos esperados registrados por ponteiro)'
{$endif}
    + ': ';
  BytesMessage = ' bytes: ';
  AnsiStringBlockMessage = 'AnsiString';
  UnicodeStringBlockMessage = 'UnicodeString';
  LeakMessageFooter = #13#10
{$ifndef HideMemoryLeakHintMessage}
    + #13#10'Nota: '
  {$ifdef RequireIDEPresenceForLeakReporting}
    + 'Essa checagem de vazamento de memria somente  feita se o Delphi est rodando atualmente no mesmo computador. '
  {$endif}
  {$ifdef FullDebugMode}
    {$ifdef LogMemoryLeakDetailToFile}
    + 'O detalhe do vazamento de memria est logado em um arquivo texto na mesma pasta que essa aplicao. '
    {$else}
    + 'Habilite o DEFINE "LogMemoryLeakDetailToFile" para obter um arquivo de log contendo detalhes dos vazamentos de memria. '
    {$endif}
  {$else}
    + 'Para obter um arquivo de log contendo detalhes dos vazamentos de memria, habilite os DEFINES "FullDebugMode" e "LogMemoryLeakDetailToFile". '
  {$endif}
    + 'Para desabilitar essa checagem de vazamento de memria, desabilite o DEFINE "EnableMemoryLeakReporting".'#13#10
{$endif}
    + #0;
  LeakMessageTitle = 'Vazamento de memria detectado';
{$ifdef UseOutputDebugString}
  FastMMInstallMsg = 'FastMM foi instalado.';
  FastMMInstallSharedMsg = 'Compartilhando uma instancia existente do FastMM.';
  FastMMUninstallMsg = 'FastMM foi desinstalado.';
  FastMMUninstallSharedMsg = 'Parando de compartilhar uma instancia existente do FastMM.';
{$endif}
{$ifdef DetectMMOperationsAfterUninstall}
  InvalidOperationTitle = 'Operao no Gerenciador de Memria aps desinstalao.';
  InvalidGetMemMsg = 'FastMM detectou uma chamada GetMem depois que o FastMM foi desinstalado.';
  InvalidFreeMemMsg = 'FastMM detectou uma chamada FreeMem depois que o FastMM foi desinstalado.';
  InvalidReallocMemMsg = 'FastMM detectou uma chamada ReallocMem depois que o FastMM foi desinstalado.';
  InvalidAllocMemMsg = 'FastMM detectou uma chamada ReallocMem depois que o FastMM foi desinstalado.';
{$endif}

implementation

end.

